// SpamMailEraser
//   SpamMailEraser.c++
//       2004 Y.Senta

#include <stdlib.h>

#include "Command.h"
#include "POPnetLib.h"

#define VER "v0.02"

#define DOTFILE "/.spamrule"

void usage(){
  printf ("SpamMailEraser %s   (Y.Senta 2005)\n", VER);
  printf ("Usage: SpamMailEraser [-e]/[-f testfile]/[-l]/[-t]/[-h]\n");
  printf (" -e: Connect server, check and delete\n");
  printf (" -f: Load file and check\n");
  printf (" -l: Connect server, check, delete and dump\n");
  printf (" -t: Connect server, check and dump\n");
  printf (" -h: Show help\n");
  exit(1);
}

int main(int argc, char **argv){
  if (argc<2)
    usage();

  bool bFileMode = false;
  bool bDumpMode = false;
  bool bDeleteMode = false;

  if (!strcmp(argv[1], "-e")){
    bDeleteMode = true;
  } else if (!strcmp(argv[1], "-f")){
    bFileMode = true;
  } else if (!strcmp(argv[1], "-l")){
    bDeleteMode = true;
    bDumpMode = true;
  } else if (!strcmp(argv[1], "-t")){
    bDumpMode = true;
  } else {
    usage();
  }

  if ((bFileMode && argc != 3) || (!bFileMode && argc != 2))
    usage();

  MyString strDotFile = getenv("HOME");
  strDotFile += DOTFILE;
  
  if (bFileMode){
    Command cmd;
    if (!cmd.Load(strDotFile.GetBuffer()))
      return 1;
  
    MyStringList lst;
    if (!lst.LoadFile(argv[2]))
      return 0;

    if (cmd.DoCheck(lst))
      printf ("OK\n");
    else
      printf ("NG\n");
  } else {
    POPnetLib pop;
    if (pop.Init(strDotFile.GetBuffer()))
      pop.Check(bDeleteMode, bDumpMode);
  }

  return 0;
}
