//   md5.h
//       2004 Y.Senta

#ifndef _MD5_H_
#define _MD5_H_

// This class made by sample codes of RFC1321

typedef unsigned long int UINT4;

class md5{
  unsigned char m_hash[16];
  
  struct MD5Contex {
    UINT4 state[4];
    UINT4 count[2];
    unsigned char buffer[64];
  } m_Contex;
  
  void Init();
  void Update(unsigned char *, int);
  void ContexCpy(int, const unsigned char *, int);
  void Transform (unsigned char [64]);
  void Decode (UINT4 *, unsigned char *, unsigned int);
  void Final();
  void Encode (unsigned char *, UINT4 *, unsigned int);
  
  
  inline UINT4 ROTATE_LEFT(UINT4 x, UINT4 n){
    return (x << n) | (x >> (32-n));
  }
  
  inline void FF(UINT4 *a, UINT4 b, UINT4 c, UINT4 d, UINT4 x, UINT4 s, UINT4 ac) {
    *a += ((b & c) | (~b & d)) + x + ac;
    *a = ROTATE_LEFT (*a, s);
    *a += (b);
  }
  
  inline void GG(UINT4 *a, UINT4 b, UINT4 c, UINT4 d, UINT4 x, UINT4 s, UINT4 ac) {
    *a += ((b & d) | (c & ~d)) + x + ac;
    *a = ROTATE_LEFT (*a, s);
    *a += b;
  }
  
  inline void HH(UINT4 *a, UINT4 b, UINT4 c, UINT4 d, UINT4 x, UINT4 s, UINT4 ac) {
    *a += (b ^ c ^ d) + x + ac;
    *a = ROTATE_LEFT (*a, s);
    *a += b;
  }
  
  inline void II(UINT4 *a, UINT4 b, UINT4 c, UINT4 d, UINT4 x, UINT4 s, UINT4 ac) {
    *a += (c ^ (b | ~d)) + x + ac;
    *a = ROTATE_LEFT (*a, s);
    *a += b;
  }
  
  
 public:
  md5();
  ~md5();
  
  char *GetString(const char *);
};

#endif
